#ifndef __PREMETA_H__
#define __PREMETA_H__

#include "FastFit.h"
#include "VcfRecord.h"
#include "VcfFileReader.h"
#include "VcfHeader.h"

class PreMeta
{
    public:
        PreMeta();
        ~PreMeta();
        static bool vcfAnnotated;
	
	//Input/Output options	
	static String vcfInput;
	static String outputFile;
	static int Xstart,Xend;
	static String xLabel;;
	static bool dosage;
	static bool genoFromPed;
	static bool genoFromVCF;
	static bool FounderFreq;
	static int window;

	int numFounders;

	VcfFileReader reader;
	VcfHeader header;
	VcfRecord record;

	//this is the position of each marker in a gene for output
	int pos;
	double founderMaf,markerMaf;
	String chr,refAllele,rareAllele;
	double mac;
	Vector genotype;

	void Run(Pedigree & ped, FastTransform & trans,FastFit & engine, String & traitName);
	void VCFSanityCheck();
	bool GetGenotypeVectorVCFDosage(FastTransform & trans, Pedigree & ped);
	bool GetGenotypeVectorVCF(FastTransform & trans, Pedigree & ped);
	bool GetGenotypeVectorPED(FastTransform & trans, Pedigree & ped,int markerid);
	bool GetGenotypeVector(FastTransform & trans, Pedigree & ped,int markerid);
	void PrintHeader(FILE * output,FastFit & engine,FastTransform & trans);
	double CalculateCov(FastFit & engine,FastTransform & trans, Pedigree & ped, Matrix & genotypeAl,Vector & sigma2,int m);
};

#endif
